% Nested Support Vector Machines
% NOC-SVM demo
% 
% Gyemin Lee, University of Michigan
% 2009.5.17
% 
clear
home

datastr = 'banana';
dataidx = '1';

% 
% NOC-SVM test
% 
% training data set
xt = util_rdbenchdata(datastr, dataidx, 'train', -1);

% kenel bandwidth
noc_sigma = 0.5;

% breakpoints
noc_lambdamax = ocsvm_lambdamax(xt, @knl_radial, noc_sigma);
noc_lambdanum = 11;
noc_lambdamin = min([noc_lambdamax/noc_lambdanum, 1e-6]);
noc_lambda = linspace(noc_lambdamax, noc_lambdamin, noc_lambdanum)';

% train NOC-SVM
[noc_alpha, noc_ff, noc_dual, noc_dd] = nocsvm(xt, @knl_radial, noc_sigma, noc_lambda);

% plot decision boundaries
figure(3)
plot_ocsvm_set(xt,@knl_radial,noc_sigma,noc_lambda,noc_alpha);
